题目描述
给你一个整数数组 matches
其中 matches[i] = [winneri, loseri]
表示在一场比赛中 winneri
击败了 loseri
。
返回一个长度为 2 的列表 answer
:
answer[0]
是所有 没有 输掉任何比赛的玩家列表。
answer[1]
是所有恰好输掉 一场 比赛的玩家列表。
两个列表中的值都应该按 递增 顺序返回。
注意:
- 只考虑那些参与 至少一场 比赛的玩家。
- 生成的测试用例保证 不存在 两场比赛结果 相同 。
示例 1:
输入:matches = [[1,3],[2,3],[3,6],[5,6],[5,7],[4,5],[4,8],[4,9],[10,4],[10,9]]
输出:[[1,2,10],[4,5,7,8]]
解释:
玩家 1、2 和 10 都没有输掉任何比赛。
玩家 4、5、7 和 8 每个都输掉一场比赛。
玩家 3、6 和 9 每个都输掉两场比赛。
因此,answer[0] = [1,2,10] 和 answer[1] = [4,5,7,8] 。
示例 2:
输入:matches = [[2,3],[1,3],[5,4],[6,4]]
输出:[[1,2,5,6],[]]
解释:
玩家 1、2、5 和 6 都没有输掉任何比赛。
玩家 3 和 4 每个都输掉两场比赛。
因此,answer[0] = [1,2,5,6] 和 answer[1] = [] 。
提示:
1 <= matches.length <= 105
matches[i].length == 2
1 <= winneri, loseri <= 105
winneri != loseri
- 所有
matches[i]
互不相同
解法
方法一:哈希表 + 排序
我们用一个哈希表 $\textit{cnt}$ 记录每个玩家输掉的比赛场次。
然后遍历哈希表,将输掉 $0$ 场比赛的玩家放入 $\textit{ans}[0]$,将输掉 $1$ 场比赛的玩家放入 $\textit{ans}[1]$。
最后将 $\textit{ans}[0]$ 和 $\textit{ans}[1]$ 按照升序排序,返回结果。
时间复杂度 $O(n \times \log n)$,空间复杂度 $O(n)$。其中 $n$ 为比赛场次数。
1
2
3
4
5
6
7
8
9
10
11
12 | class Solution:
def findWinners(self, matches: List[List[int]]) -> List[List[int]]:
cnt = Counter()
for winner, loser in matches:
if winner not in cnt:
cnt[winner] = 0
cnt[loser] += 1
ans = [[], []]
for x, v in sorted(cnt.items()):
if v < 2:
ans[v].append(x)
return ans
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18 | class Solution {
public List<List<Integer>> findWinners(int[][] matches) {
Map<Integer, Integer> cnt = new HashMap<>();
for (var e : matches) {
cnt.putIfAbsent(e[0], 0);
cnt.merge(e[1], 1, Integer::sum);
}
List<List<Integer>> ans = List.of(new ArrayList<>(), new ArrayList<>());
for (var e : cnt.entrySet()) {
if (e.getValue() < 2) {
ans.get(e.getValue()).add(e.getKey());
}
}
Collections.sort(ans.get(0));
Collections.sort(ans.get(1));
return ans;
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19 | class Solution {
public:
vector<vector<int>> findWinners(vector<vector<int>>& matches) {
map<int, int> cnt;
for (auto& e : matches) {
if (!cnt.contains(e[0])) {
cnt[e[0]] = 0;
}
++cnt[e[1]];
}
vector<vector<int>> ans(2);
for (auto& [x, v] : cnt) {
if (v < 2) {
ans[v].push_back(x);
}
}
return ans;
}
};
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18 | func findWinners(matches [][]int) [][]int {
cnt := map[int]int{}
for _, e := range matches {
if _, ok := cnt[e[0]]; !ok {
cnt[e[0]] = 0
}
cnt[e[1]]++
}
ans := make([][]int, 2)
for x, v := range cnt {
if v < 2 {
ans[v] = append(ans[v], x)
}
}
sort.Ints(ans[0])
sort.Ints(ans[1])
return ans
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18 | function findWinners(matches: number[][]): number[][] {
const cnt: Map<number, number> = new Map();
for (const [winner, loser] of matches) {
if (!cnt.has(winner)) {
cnt.set(winner, 0);
}
cnt.set(loser, (cnt.get(loser) || 0) + 1);
}
const ans: number[][] = [[], []];
for (const [x, v] of cnt) {
if (v < 2) {
ans[v].push(x);
}
}
ans[0].sort((a, b) => a - b);
ans[1].sort((a, b) => a - b);
return ans;
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22 | /**
* @param {number[][]} matches
* @return {number[][]}
*/
var findWinners = function (matches) {
const cnt = new Map();
for (const [winner, loser] of matches) {
if (!cnt.has(winner)) {
cnt.set(winner, 0);
}
cnt.set(loser, (cnt.get(loser) || 0) + 1);
}
const ans = [[], []];
for (const [x, v] of cnt) {
if (v < 2) {
ans[v].push(x);
}
}
ans[0].sort((a, b) => a - b);
ans[1].sort((a, b) => a - b);
return ans;
};
|